View Issue Details

IDProjectCategoryView StatusLast Update
0000368OpenMPT[All Projects] Feature Requestpublic2014-12-21 00:33
ReporterharbingerAssigned ToSaga Musix 
PrioritynormalSeverityfeatureReproducibilityN/A
Status resolvedResolutionfixed 
Platformx86OSWindowsOS VersionXP
Product VersionOpenMPT 1.22.01.00 (upgrade first) 
Target VersionOpenMPT 1.24.01.00 / libopenmpt 0.2-beta8 (upgrade first)Fixed in VersionOpenMPT 1.24.01.00 / libopenmpt 0.2-beta8 (upgrade first) 
Summary0000368: Linked samples in MPTM format
Description

The nice thing about ITP files is that you can link to samples rather than embed them in the track, saving space on your HD (since you're not duplicating the waveform).
In my projects, i use MPTM to not only to assemble the track but also to mix vocals thru plugins. I arrange the plugins and samples into the music track, play it and record the vocal track in Audacity and save that file, then import the real audio as a sample in MPT. The problem is, i'm duplicating a 30+ MB waveform needlessly.

I'd love if there were like a checkbox either on the Samples page or the Comments page for any sample i wish to link to rather than embed. This would keep file size down and as well as HD footprint. Of course the disadvantage would be that i could not manipulate the linked waveform from within ModPlug.

As an extra bonus, the Cleanup Manager would allow the user to remove embedded waveforms and use the links as expressed in the File field on the Samples page. (It might be good to move the Pitch Shift group down a little so the File field can be lengthened.)

TagsNo tags attached.
Has the bug occurred in previous versions?
Tested code revision (in case you know it)

Activities

Saga Musix

Saga Musix

2013-04-07 17:25

administrator   ~0001160

Magnet links for samples are already on the must-have feature list for the new and improved MPTM format. Don't ask me when that is going to happen, though... To reduce hard disk usage, you can try using IT-compressed samples: http://forum.openmpt.org/index.php?topic=4961.0

Saga Musix

Saga Musix

2014-03-01 21:54

administrator   ~0001562

Skaven's ideas from http://forum.openmpt.org/index.php?topic=2515.0 (revised ITP functionality):

  • The existing .ITP functionality is scrapped
  • Make the Samples to have relative file paths, which are saved with the song
  • Implement "Set Path" command to Samples instead of Instruments. This allows the user to replace a sample if needed, or to fix a broken link.
  • Implement a "Reload Sample" command, to refresh the sample if it has been edited in an external editor while the .ITP is opened.
  • Implement functionality for automatically turning an existing .IT to an .ITP (automatically saves all the .IT's samples to a specified folder and creates relative paths to them).
  • Implement "Save As.." functionality to easily save an .IT copy from an .ITP for distribution or further processing, such as MO3 encoding. (The user can also convert an .ITP back to .IT by just changing the song type, just like before.)
  • For easily porting instruments between songs and for creating an instrument library, a new "Instrument with relative paths" file format which saves the parameter data but NOT the samples, just paths.

I think it would be a good idea to ditch the ITP format (make it import-only) and add functionality to link samples to the MPTM format. Any sample metadata (frequency, loop points, etc.) from the referenced WAV/FLAC/etc. sample would be overriden by the stuff stored in the MPTM file, only the waveform would be imported.

Saga Musix

Saga Musix

2014-10-26 16:03

administrator   ~0001824

I have now pretty much implemented Skaven's ideas, removed ITP support (or rather, make ITP support read-only) and added on-disk samples for MPTM and instruments.
In the instrument editor, you can choose "Impulse Tracker Instruments with external Samples" from the Save Dialog's type list to keep sample references in ITI files.
Further testing would be appreciated. :)

Issue History

Date Modified Username Field Change
2013-04-07 16:55 harbinger New Issue
2013-04-07 17:25 Saga Musix Note Added: 0001160
2014-03-01 21:54 Saga Musix Note Added: 0001562
2014-10-24 21:09 Saga Musix Assigned To => Saga Musix
2014-10-24 21:09 Saga Musix Status new => assigned
2014-10-24 21:09 Saga Musix Target Version => OpenMPT 1.24.01.00 / libopenmpt 0.2-beta8 (upgrade first)
2014-10-26 16:03 Saga Musix Note Added: 0001824
2014-10-26 16:03 Saga Musix Status assigned => feedback
2014-12-21 00:33 Saga Musix Status feedback => resolved
2014-12-21 00:33 Saga Musix Resolution open => fixed
2014-12-21 00:33 Saga Musix Fixed in Version => OpenMPT 1.24.01.00 / libopenmpt 0.2-beta8 (upgrade first)